import pickle
import os

def _get_file_name():
	folder = os.path.abspath(os.path.dirname(__file__))
	return os.path.join(folder,'high_scores.pickle')
def _get_pickle():
	try:
		f = file(_get_file_name(),"rb")
		pick = pickle.loads(f.read())
		f.close()
		return pick
	except:
		return []
def _set_pickle(pick):
	f = file(_get_file_name(),"wb")
	f.write(pickle.dumps(pick))
	f.close()

def get_level_dict(level_config):
	try:
		level_config = level_config.__class__
	except:
		pass
	d = level_config.__dict__.copy()
	for key_name in d.keys():
		if key_name.startswith("_"):
			d.pop(key_name)
	keys = d.keys()
	keys.sort()
	return [(key,d[key]) for key in keys]
	
def check(level_config):
	pick = _get_pickle()
	d = get_level_dict(level_config)
	for pair in pick:
		if pair[0] == d:
			return pair[1]
	return None

def update(level_config, time):
	pick = _get_pickle()
	d = get_level_dict(level_config)
	for pair in pick:
		if pair[0] == d:
			pair[1] = time
			_set_pickle(pick)
			return
	#else:
	pick.append([d, time])
	_set_pickle(pick)
