class Vector2:
	def __init__(self,x=0,y=0):
		self.x = x
		self.y = y
	
	def __mul__(self, number):
		return Vector2(self.x * number, self.y * number)
	
	def __add__(self, other):
		return Vector2(self.x+other.x, self.y+other.y)
	def __sub__(self, other):
		return Vector2(self.x-other.x, self.y-other.y)
	def __iadd__(self, other):
		self.x += other.x
		self.y += other.y
		return self
	def __isub__(self, other):
		self.x -= other.x
		self.y -= other.y
		return self
	
	def __eq__(self, other):
		return self.x == other.x and self.y == other.y
	
	def __str__(self):
		return "<Vector2 x:%d y:%d>" % (self.x,self.y)
